package net.postchain.rell.codegen.javascript

import net.postchain.rell.codegen.deps.ClassName
import net.postchain.rell.codegen.document.AbstractDocument

class JavascriptDocument(moduleName: String) : AbstractDocument(
        "// Generated by javascript generator",
        moduleName
) {
    override fun formatPackageString() = ""

    override fun formatImportString(className: ClassName) = "import { ${className.className} } from \"${formatImportPath(className)}\";"

    private fun formatImportPath(className: ClassName): String {
        val relativePath = module.split(".").joinToString("") { "../" }
        val modulePath = className.module.replace(".", "/")
        val typescriptFileName = if (className.module.isBlank()) "root" else "/${className.module.replace(".", "_")}"
        return "$relativePath$modulePath$typescriptFileName"
    }
}
